package JavaPonies;
/*
 * This is the structure for Pony behaviors
 */
import javax.swing.ImageIcon;

import java.awt.*;
import java.util.LinkedList;
import java.util.List;

public class Behavior {
    public String Name;
    public double chance_of_occurance;
    public int MaxDuration;
    public int MinDuration;
    public int speed;
    
    public ImageIcon current_image;
    
    public ImageIcon right_image;
    public String right_image_path;
    public ImageIcon left_image;
    public String left_image_path;

    public WinMain.AllowedMoves Allowed_Movement;

    public int timeleft;
    public boolean vertical = false;
    public boolean horizontal = false;
    public boolean up = false;
    public boolean right = true;

    public String Linked_Behavior_Name = "";
    public Behavior Linked_Behavior;
    public String Start_Line;
    public String End_Line;
    public boolean Skip = false;
    
    public int destination_xcoord;
    public int destination_ycoord;
    public String follow_object_name = "";
    public Window follow_object;
    
    public int delay = 0;
    
    public List<effect> Effects = new LinkedList<effect>();
    
    // Get the destination location for whatever we are following
    public Point Get_Destination(GraphicsDevice current_screen) {
    	// If we aren't following anything yet
    	if (follow_object_name.length() > 0 && follow_object == null) {
    		List<Pony_Form> ponies_to_follow = new LinkedList<Pony_Form>();
    		// Look for a Pony to follow    		
            for (Pony pony : WinMain.currentInstance.Active_Ponies) {
                if (pony.Name.equalsIgnoreCase(follow_object_name))
                    ponies_to_follow.add(pony.Form);
            }

            // If one or more ponies found
            if (ponies_to_follow.size() > 0) {
            	// Select one at random to follow
                int dice = WinMain.rand.nextInt(ponies_to_follow.size());
                follow_object = ponies_to_follow.get(dice);
                return follow_object.getLocation();
            }

            List<Effect_Form> effects_to_follow = new LinkedList<Effect_Form>();
            // Look for an object (effect) to follow
            for(Effect_Form effect : WinMain.currentInstance.Active_Effects) {
                if (effect.effect_name.equalsIgnoreCase(follow_object_name)) {
                    effects_to_follow.add(effect);
                }
            }

            // If one or more objects found
            if (effects_to_follow.size() > 0) {
            	// Select one at random to follow
                int dice = WinMain.rand.nextInt(effects_to_follow.size());
                follow_object = effects_to_follow.get(dice);
                return follow_object.getLocation();
            }
    	}
    	// If we are following an object
	    if (follow_object != null)
	        return follow_object.getLocation(); // Return its current screen position

	    // If we have a coordinate to go to
	    if (destination_xcoord != 0 && destination_ycoord != 0) {
	    	// Return its position on the screen
	    	Rectangle screenBounds = current_screen.getDefaultConfiguration().getBounds();
	        return new Point((int)(((destination_xcoord * screenBounds.getWidth()) / 100) + screenBounds.getMinX()),
	                         (int)(((destination_ycoord * screenBounds.getHeight()) / 100) + screenBounds.getMinY()));
	    }

	    // Otherwise return a blank Point
    	return new Point();
    }
    
    // Add an effect to this behavior
    public void AddEffect(String effectname, ImageIcon image, int duration, int repeat_delay, WinMain.Directions direction, WinMain.Directions centering, boolean follow) {
    	effect new_effect = new effect();
    	
        new_effect.name = effectname;
        new_effect.image = image;
        new_effect.duration = duration;
        new_effect.repeat_delay = repeat_delay;
        new_effect.placement_direction = direction;
        new_effect.follow = follow;
        new_effect.centering = centering;

        Effects.add(new_effect);
    }
}
